/***************************************************************************
 *            ftwindow.h
 *
 *  Thu Feb 10 01:03:44 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _FTWINDOW_H
#define _FTWINDOW_H

#include <gtk/gtk.h>
#include <sys/stat.h>
#include "basicwindow.h"
#include "settings.h"
#include "requestdialog.h"
#include "gettext.h"
#include "userutilities.h"


enum
{
	FTCOL_FILENAME,
	FTCOL_REALNAME,
	FTCOL_SIZESTR,
	FTCOL_SELECTED,
	FTCOL_SIZE
};


class fileTransferWindow: public basicWindow
{
	public:
		requestDialog	*request;
	
		fileTransferWindow(gboolean _isServer);
		~fileTransferWindow();
	
		virtual void focusWindow();
	
		void createRequestDialog(fileEventInfo* event);
		void addFilesFromURIList(gchar* URI, GtkTreeIter* whereToAdd = NULL);
		
		
	private:
		gboolean 	isServer;
	
		GtkWidget	*dirEntry,
					*filesTv,
					*filesInfo,
					*statusInfo,
					*closeButton,
					*fileUpButton,
					*fileDownButton;
	
		// info widgets for an actual file
		GtkWidget	*info1Sent,
					*info1No,
					*info1Name,
					*info1Elapsed,
					*info1Remaining,
					*info1Progress;
	
		// info widgets for general sending
		GtkWidget	*info2Sent,
					*info2CPS,
					*info2Elapsed,
					*info2Remaining,
					*info2Progress;
	
		GtkListStore *filesStore;
	
		virtual GtkWidget*	createWindowContent();
		virtual void 		destroyWindowContent();
		virtual gboolean 	eventCallback(gint command, gint lastResult, gpointer info);
	
		GtkWidget* 			createButtonbar();
	
		GtkWidget* 			createRemoteRequestWidget(fileEventInfo* event);
		
		GtkWidget* 			createFileList(gboolean createButtons);
		void				setFileInfo();
		void				showAddFileDialog();
		gboolean			addFile(gchar* fileName, GtkTreeIter* iterToInsert = NULL);
		void				removeSelectedFiles();
		void				moveSelectedFiles(gboolean moveUp);
		
		void				stopFileTransfer();
	
	
		// callbacks
		static void cb_requestCallback(gint result, gpointer info, fileTransferWindow* ftw);
		
		static void cb_addFileButtonClicked(fileTransferWindow* ftw);
		static void cb_removeFileButtonClicked(fileTransferWindow* ftw);
		static void cb_moveFileUpButtonClicked(fileTransferWindow* ftw);
		static void cb_moveFileDownButtonClicked(fileTransferWindow* ftw);
		
		static void cb_fileListCursorChanged(fileTransferWindow* ftw);
		static void cb_fileListFileDropped(fileTransferWindow* ftw, 
										   GdkDragContext   *drag_context,
                                            gint              x,
                                            gint              y,
                                            GtkSelectionData *data,
                                            guint             info,
                                            guint             time);
		
		static void cb_closeButtonClicked(fileTransferWindow* ftw);
};


#endif /* _FTWINDOW_H */
