/***************************************************************************
 *            gpgmanager.h
 *
 *  Wed Mar 22 03:23:20 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/



#ifndef _GPGMANAGER_H
#define _GPGMANAGER_H


#include <gtk/gtk.h>
#include "basicwindow.h"
#include "icons.h"
#include "selectuser.h"
#include "imuserdaemon.h"


class GPGKeyWindow: public basicWindow, public IMSignalSource
{
	public:
		GPGKeyWindow();
		~GPGKeyWindow();
		
	private:
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
};


class GPGManagerWindow: public basicWindow
{
	public:
		GPGManagerWindow();
		~GPGManagerWindow();
	
	private:
		GtkListStore *gpgUsersStore;
		GtkWidget	 *ownKeyEntry,
					 *gpgUsersView,
					 *addButton,
					 *removeButton,
					 *getInfoButton,
					 *setKeyButton;
		GList		 *gpgUsers;
	
		selectUserWindow	*addUsersWindow;
		GPGKeyWindow		*gpgSelectWindow;
	
		GtkWidget* createWindowContent();
		void	   destroyWindowContent();
	
		GtkWidget* createButtonbar();
		GtkWidget* createUsersList();
	
	
		// callbacks
		static void cb_addButtonClicked(GPGManagerWindow* self);
		static void cb_removeButtonClicked(GPGManagerWindow* self);
		static void cb_getInfoButtonClicked(GPGManagerWindow* self);
		static void cb_selectUserKeyButtonClicked(GPGManagerWindow* self);
		static void cb_selectOwnKeyButtonClicked(GPGManagerWindow* self);

		static void cb_selectionChanged(GPGManagerWindow* self);
		static void cb_activeToggled(GPGManagerWindow* self, gchar* path_str);

		static gboolean cb_addWindowClosedCallback(userEventType type, gint command, gint lastResult, gpointer info, GPGManagerWindow* self);

};





#endif /* HAVE_LIBGPGME */
