/***************************************************************************
 *            imuserdaemon.h
 *
 *  Thu Jan 20 00:08:55 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef IMUSERDAEMON_H

#define IMUSERDAEMON_H

#include <time.h>
#include <gtk/gtk.h>
#include <pthread.h>
#include <sys/stat.h>

#include "licq_chat.h"
#include "licq_icqd.h"
#include "licq_filetransfer.h"
#include "licq_sar.h"
#include "systemcharset.h"
#include "licq_languagecodes.h"
#include "licq_countrycodes.h"
#include "licq_interestcodes.h"
#include "licq_organizationcodes.h"
#include "licq_backgroundcodes.h"
#include "gettext.h"




// circumlocution :)

#define EVENT_RESULT_ACKED	 	EVENT_ACKED
#define EVENT_RESULT_SUCCESS 	EVENT_SUCCESS
#define EVENT_RESULT_FAILED 	EVENT_FAILED
#define EVENT_RESULT_TIMEOUT 	EVENT_TIMEDOUT
#define EVENT_RESULT_ERROR 		EVENT_ERROR

#define EVENT_REQUEST_ACCEPTED	0xF111
#define EVENT_REQUEST_REFUSED	0xF112

// file events
#define FEVENT_RES_STARTFILE 	FT_STARTxFILE
#define FEVENT_RES_CONFIRM		FT_CONFIRMxFILE
#define FEVENT_RES_STARTBATCH 	FT_STARTxBATCH
#define FEVENT_RES_DONEFILE 	FT_DONExFILE
#define FEVENT_RES_DONEBATCH 	FT_DONExBATCH
#define FEVENT_RES_UPDATE		FT_UPDATE
#define FEVENT_RERR_BIND		FT_ERRORxBIND
#define FEVENT_RERR_CONNECT 	FT_ERRORxCONNECT
#define FEVENT_RERR_RES			FT_ERRORxRESOURCES
#define FEVENT_RERR_DISCONNECT 	FT_ERRORxCLOSED
#define FEVENT_RERR_FILE		FT_ERRORxFILE
#define FEVENT_RERR_HANDSHAKE 	FT_ERRORxHANDSHAKE



// chat events
#define CEVENT_FONT_FGCOLOR 	CHAT_COLORxFG            
#define CEVENT_FONT_BGCOLOR 	CHAT_COLORxBG   
#define CEVENT_FONT_FAMILY 		CHAT_FONTxFAMILY       
#define CEVENT_FONT_FACE 		CHAT_FONTxFACE         
#define CEVENT_FONT_SIZE 		CHAT_FONTxSIZE   

#define CEVENT_CHAR_BACKSPACE 	CHAT_BACKSPACE  
#define CEVENT_CHAR_NEWLINE 	CHAT_NEWLINE  
#define CEVENT_CHAR 			CHAT_CHARACTER  

#define CEVENT_KICK 			CHAT_KICK  
#define CEVENT_KICKED 			CHAT_DISCONNECTIONxKICKED
#define CEVENT_KICKYOU 			CHAT_KICKxYOU            
#define CEVENT_KICKFAIL 		CHAT_KICKxFAIL  
#define CEVENT_KICKPASS 		CHAT_KICKxPASS  
#define CEVENT_KICKYES 			CHAT_KICKxYES           
#define CEVENT_KICKNO 			CHAT_KICKxNO  

#define CEVENT_FOCUSIN 			CHAT_FOCUSxIN            
#define CEVENT_FOCUSOUT 		CHAT_FOCUSxOUT                   
         
#define CEVENT_DISCONNECT 		CHAT_DISCONNECTION       
#define CEVENT_CONNECT 			CHAT_CONNECTION             
    
#define CEVENT_SLEEPOFF 		CHAT_SLEEPxOFF         
#define CEVENT_SLEEPON 			CHAT_SLEEPxON           
           
#define CEVENT_BEEP 			CHAT_BEEP   
#define CEVENT_LAUGH 			CHAT_LAUGH  
         
#define CEVENT_ERR_CONNECT 		CHAT_ERRORxCONNECT      
#define CEVENT_ERR_BIND 		CHAT_ERRORxBIND         
#define CEVENT_ERR_RES 			CHAT_ERRORxRESOURCES   



// user events
#define USER_UPDATE_STATUS		USER_STATUS
#define USER_UPDATE_EVENTS		USER_EVENTS
#define USER_UPDATE_BASIC		USER_BASIC
#define USER_UPDATE_EXT			USER_EXT
#define USER_UPDATE_GENERAL		USER_GENERAL
#define USER_UPDATE_MORE		USER_MORE
#define USER_UPDATE_WORK		USER_WORK
#define USER_UPDATE_ABOUT		USER_ABOUT
#define USER_UPDATE_SECURITY	USER_SECURITY
#define USER_UPDATE_MORE2		USER_MORE2
#define USER_UPDATE_HP			USER_HP
#define USER_UPDATE_PHONES		USER_PHONExBOOK
#define USER_UPDATE_PICTURE		USER_PICTURE
#define USER_UPDATE_TYPING		USER_TYPING
#define USER_UPDATE_ALL			0xC01A



// status events / states
#define BUDDY_STATUS_OFFLINE ICQ_STATUS_OFFLINE
#define BUDDY_STATUS_DND	 ICQ_STATUS_DND
#define BUDDY_STATUS_OCC	 ICQ_STATUS_OCCUPIED
#define BUDDY_STATUS_NA		 ICQ_STATUS_NA
#define BUDDY_STATUS_AWAY	 ICQ_STATUS_AWAY
#define	BUDDY_STATUS_FFC	 ICQ_STATUS_FREEFORCHAT
#define BUDDY_STATUS_ONLINE	 ICQ_STATUS_ONLINE
#define BUDDY_STATUS_INV	 ICQ_STATUS_FxPRIVATE
#define BUDDY_STATUS_CONNECT 0x1000
#define BUDDY_INV_SET		 0x1001

#define USER_EVENT_CHAT			ICQ_CMDxSUB_CHAT
#define USER_EVENT_FILE			ICQ_CMDxSUB_FILE
#define USER_EVENT_MESSAGE   	ICQ_CMDxSUB_MSG
#define USER_EVENT_URL		 	ICQ_CMDxSUB_URL
#define USER_EVENT_AUTH_ACCEPT	ICQ_CMDxSUB_AUTHxGRANTED
#define USER_EVENT_AUTH_REFUSE	ICQ_CMDxSUB_AUTHxREFUSED
#define USER_EVENT_AUTH_REQUEST	ICQ_CMDxSUB_AUTHxREQUEST
#define USER_EVENT_SECURE_OPEN	ICQ_CMDxSUB_SECURExOPEN
#define USER_EVENT_SECURE_CLOSE	ICQ_CMDxSUB_SECURExCLOSE
#define USER_EVENT_SECURE_OLD	ICQ_CMDxSUB_SECURExOLD
#define USER_EVENT_CONTACTS		ICQ_CMDxSUB_CONTACTxLIST
#define USER_EVENT_WEBPANEL		ICQ_CMDxSUB_WEBxPANEL
#define USER_EVENT_PAGER		ICQ_CMDxSUB_EMAILxPAGER
#define USER_EVENT_SERVERMSG	ICQ_CMDxSUB_MSGxSERVER

#define USER_EVENT_ADDED_TO_LIST	ICQ_CMDxSUB_ADDEDxTOxLIST

//! event operations for addEvent() and deleteEvent()
enum eventOperations
{
	EO_LAST 	= 1,
	EO_FIRST 	= 2,
	EO_ALL		= 4,
	EO_NORMAL 	= 8,
	EO_SUNKEN 	= 16,
	EO_SYSTEM	= 32
};


//! event manager identifiers
enum userEventType
{
	UE_UNDEFINED,
	UE_MESSAGE,
	UE_FILETRANSFER,
	UE_FILETRANSFERREQUEST,
	UE_CHAT,
	UE_CHATREQUEST,
	UE_URL,
	UE_USERINFO,
	UE_AUTHORIZATION,
	UE_AUTHORIZATIONREQUEST,
	UE_AUTHORIZATIONGRANT,
	UE_AUTHORIZATIONREFUSE,
	UE_AUTORESPONSEGET,
	UE_AUTORESPONSESET,
	UE_CONTACTS,
	UE_CONTACTSREQUEST,
	UE_HISTORY,
	UE_ENCRYPTION,
	UE_WHITEPAGES,
	UE_SETRANDOMCHAT,
	UE_STARTRANDOMCHAT,
	UE_ADDUSER,
	UE_EDITGROUPS,
	UE_ADDEDTOLIST,
	UE_EDITUSERMODES,
	UE_REGISTEROWNER,
	UE_MANAGEOWNERS,
	UE_SETOWNERPROPERTIES,
	UE_LOGMESSAGES,
	UE_OPTIONS,
	UE_GPGMANAGER,
	UE_ENCRYPTGPG,
	UE_WEBPANEL,
	UE_PAGER,
	UE_SERVERMSG,
	UE_USERLISTS,
	UE_STATISTICS
};


//! events
enum notificationTypes
{
	// owner commands
	OC_NEWGROUP,
	OC_NEWUSER,
	OC_NEWUSER_NOGROUP,
	
	// initial loading
	OC_LOADUSER,
	OC_LOADGROUP,
	OC_LOADFINISH,
	
	OC_REMOVEUSER,
	OC_REMOVEGROUP,
	OC_UPDATEGROUPS,
	
	
	OC_UPDATELIST,
	OC_UPDATEUSER,
	OC_SETSTATE,
	OC_EVENT_ADDED,
	OC_EVENT_DELETED,
	
	OC_LOGON_PASSWORD_ERROR,
	OC_LOGON_RATE_ERROR,
	
	// user commands
	UC_UPDATEUSER,
	UC_UPDATE_ADDSTATE,
	UC_UPDATE_REMOVESTATE,
	UC_EVENT_RECEIVED,
	UC_EVENT_FINISHED,
	UC_SENDSERVER,
	UC_GETAUTORESPONSE,
	UC_SETAUTORESPONSE,
	UC_UPDATEMODES,
	UC_AUTORESPONSE_CHECKED,
	UC_CONVO_ADD,
	UC_CONVO_REMOVE,
	
	UC_CHATEVENT,
	UC_FILEEVENT,
	
	// plugin commands
	PC_VERIFY,
	PC_NEWOWNER,
	PC_REMOVEOWNER,
	PC_NEWPLUGIN,
	PC_REMOVEPLUGIN,
	
	// event manager commands
	EC_INSTALLED,				// a manager was installed
	EC_UNINSTALLED,				// a manager was uninstalled
	
	// history manager command
	EC_LOADHISTORY,
	
	// window commands			// FIXME: they don't belong here
	WC_DESTROYED,
	
	// misc commands
	EC_FROMMANAGER
};



//! events that a user can send during a chat
enum chatSendType
{
	CST_BEEP,
	CST_LAUGH,
	CST_CHAR,
	CST_NEWLINE,
	CST_BACKSPACE
};


enum historyReadType
{
	HRT_MESSAGE  = 1 << 0,
	HRT_URL		 = 1 << 1,
	HRT_SMS		 = 1 << 2,
	HRT_FILE	 = 1 << 3,
	HRT_CHAT	 = 1 << 4,
	HRT_CONTACT	 = 1 << 5,
	HRT_INCOMING = 1 << 6,
	HRT_OUTGOING = 1 << 7,
	HRT_ALL		 = 255
};


enum acceptMode
{
	AM_ACCEPTINAWAY,
	AM_ACCEPTINNA,
	AM_ACCEPTINOCC,
	AM_ACCEPTINDND,
	AM_AUTOACCEPTFILES,
	AM_AUTOACCEPTCHATS,
	AM_AUTOSECURE,
	AM_USEGPG,
	AM_SENDREALIP
};


// FIXME: I HATE THIS!
class IMUserDaemon;
class IMOwnerDaemon;



//! general event information
typedef struct basicEventInfo
{
	gint 		  eventID;
	gchar		  *userID;			// for backtracking
	CUserEvent*	  licqEvent;
	gint 		  type;
	time_t		  time;	
	guint		  refCount;	
	
	gboolean	  sunken,
				  isOwnerEvent;
};


typedef struct generalEventInfo
{
	basicEventInfo	*basic;
	gchar			*text;
}; 


//! message event information
typedef struct messageEventInfo: generalEventInfo
{	
	gchar*	url;
	gchar*  id;
	GdkColor fgColor,
			 bgColor;
	gboolean hasColors,
			 isSplit;
};


typedef struct contactsEventInfo: generalEventInfo
{
	GList	*contacts;
};



typedef struct fileEventInfo: generalEventInfo
{	
	gchar	*fileName;
	
	gint	fileSize,
			filePosition,
			batchSize,
			batchCount,
			batchPosition,
			batchFile;
	
	gfloat  averageSpeed,
			fileProgress,
			batchProgress;
	
	time_t	elapsed,
			remaining;
};


typedef struct chatFontInfo
{
	gchar* family;
	gboolean bold, italic, underline, strikeout;
	guchar style;
	gushort size;
	GdkColor foreground, background;	
	
};


typedef struct chatEventInfo: generalEventInfo
{	
	gchar	*userID,
			*userName;
	
	guchar	encoding;
	gchar	*character;
	gulong  toKick;
	
	gushort port;
	
	chatFontInfo font;
};



typedef struct IMUserInfoBirthday
{
	gint		year,
				month,
				day;
	gboolean 	hasBirthday;
};



typedef struct IMUserInfoLocation
{
	gchar	*city,
			*state,
			*address,
			*zip,
			*phone,
			*mobile,
			*fax;
			
	gushort country;
};


typedef struct IMUserInfoCompanyLocation: IMUserInfoLocation
{
	gchar	*department,
			*position,
			*name,
			*website;
};


typedef struct IMUserListInfo
{
	gchar	*headline;
	gint	headlineNumber;
	GList	*entries;
};



typedef struct IMHistoryEntry
{
	gchar			*text;
	historyReadType type;
	
	gboolean 		incoming;
	
	time_t			time;
};



typedef struct IMUserStatus
{
	time_t 	lastOnline,
			lastSent,
			lastReceived,
			lastAR,
			onlineSince,
			idleSince;
};


typedef struct IMUserInfoBasic
{
	gchar* alias;
	gchar* charset;
	gchar* licqID;
	gchar* formattedID;
	gchar* formattedIP;
	gchar* clientName;
	guint  status,
		   statusToUser;	
	
	guint  pluginID;
};



//! every possible user information
typedef struct IMUserInfo: public IMUserInfoBasic
{
	gushort typing;
	
	gint	localtime,
			gmtoffset;
	
	// more info stuff
	gchar	*firstname,
			*lastname,
			*email1,
			*email2,
			*email3;
	
	// even more info stuff
	gchar	*website,
			*websitecat,
			*websitedescr;
			
	gushort	age;
	gushort	language1,
			language2,
			language3;
			
	gushort	gender;	
	
	gchar	*about,
			*specialAR;
		
	gboolean onIgnoreList;	// is this user ignored ?
	gboolean onVisibleList; // is this user always visible ?
	gboolean sendViaServer;
	gboolean sendViaServerByUser;
	gboolean keepAlias;
	gboolean isOnList;
	gboolean isInvisible;
	gboolean wentJustOnline;
	
	GList	*interests,
			*organizations,
			*background;
	
	
	IMUserInfoLocation			home;
	IMUserInfoCompanyLocation	company;			
	IMUserInfoBirthday 			birthday;
	
	IMUserStatus				stats;
	
	time_t	lastUpdated;
};



typedef struct groupInfo
{
	gchar		*name;
	gint		id,
		    	num;
	gchar		*icqndID;
	guint		numUsers;
	gboolean 	opened;
};



typedef gboolean(*IMEventCallback)(userEventType type, gint command, gint lastResult, gpointer info, gpointer data);



struct IMSignalSourceCB
{
	IMEventCallback cb;
	gpointer data;
};


//! IMSignalSource -> the fundamental class for signal transportation
// FIXME: this class is not fundamental yet!
class IMSignalSource
{
	public:
		IMSignalSource();
		virtual ~IMSignalSource();

		void addCallback(IMEventCallback cb, gpointer data);
		void removeCallback(IMEventCallback cb);
	
		void clearCallbacks();
	
		gboolean containsCallback(gpointer toCheck);
	
		virtual gboolean startCallback(userEventType type, gint command, gint lastResult, gpointer data);
		
	
	private:
		GList	*callbacks;

};




//! icqEventManager: general class for managing a bundle of actions (send/receive files, send / receive messages ...)
/*!
	The IMEventManager represents the base class for all managers. The intention of a manager is
	to bundle functions and event management for specific events, for example sending/receiving of messages,
	sending/receiving of files, managing user information etc. A window can then be connected
	to that manager to be informed about events and user changes (eg the conversationWindow connects
	to the IMMessageManager) and to use its specific functions.

	IMEventManager copes with the event queue, formatting of licq events, deleting, sending callbacks ...
*/

class IMEventManager: public IMSignalSource
{
	public:
		IMUserDaemon	 *parentUser;
		userEventType	 type;
		GList			 *listensTo;
		IMUserInfo		 *info;
	
		gboolean		 canDropEvents,
						 isProcessing;
		
		//! constructor
		/*! 
			initializes the class
			\param _info: a pointer to the user information (normaly taken from IMUserDaemon::info
		*/
	
	
		//! convenince function
		gboolean startCallback(gint command, gint lastResult, gpointer data)
				 {return IMSignalSource::startCallback(type, command, lastResult, data);}
		
	
	
		IMEventManager(IMUserInfo	*_info);
		//! destructor
		virtual ~IMEventManager();	
	
		//! adds an event to the queue
		/*
			converts and then adds an event to the queue and starts a callback to inform 
			the connected function
			\param event: a licq event to convert
			\return no return value
		*/
		virtual gpointer addEvent(basicEventInfo *_basics);
	
		//! returns an event
		/*!
			returns an event according to the mask (see enum eventOperations for further details)
			\param returnFlag: a mask that specifies the event to return
			\return a pointer to the event or NULL
		*/
		virtual gpointer getEvent(gchar returnFlag);
	
		//! deletes one or more events
		/*!
			deletes one or more events according to the mask (see enum eventOperations for further details)
			\param deleteFlag: a mask that specifies the events to delete
			\return TRUE if an event was deleted
		*/
		virtual gboolean deleteEvent(gchar deleteFlag);
		
		//! tries to get an event according to the connected basicInfo out of the list
		virtual gboolean eraseEventByBasicInfo(basicEventInfo* basicInfo);
	
		//! cancels the initated event
		/*!
			cancels an event that was initated (for example through IMMessageManager::sendMessage)
			\return no return value
		*/
		virtual void cancelInitatedEvent();
		

		//! sets the sendViaServer flag
		/*!
			sets the way licq should send information. If the state was changed a
			callback is started
			\param newState: the new state
			\return no return value
		*/
		void setSendViaServer(gboolean newState);
	
		
		//! sends a callback to the im user that is connected to this manager
		virtual gboolean callUser(gint command, gpointer data);
		
		//! finishes a task
		/*!
			starts the callback function and processes additional event handling
			\param event: the licq event
			\return TRUE if the event was successfully finished
		*/
		virtual gboolean finishEvent(ICQEvent* event);
		
		//! retries to send an event if it failed
		virtual void retrySendingEvent(ICQEvent* event, gushort level = ICQ_TCPxMSG_NORMAL);
		
		//! returns true if an event is currently processing
		/*!
			\return TRUE if an event is currently processing
		*/
		virtual gboolean isEventProcessing();
		
		//! sets whether events can be dropped after they've been deleted
		void	setDropEvents(gboolean state);
				
		//! a user was added to the running conversation
		virtual void conversationUserAdded(IMUserDaemon* user);
		
		//! a user was removed from the running conversation
		virtual void conversationUserRemoved(IMUserDaemon* user);
		
	
	protected:
		GList			 *eventQueue;
		gulong			 initatedEventID;
	
		//! merges the event to fit the current manager and returns a filled struct
		/*!
			converts the licq event and creates a struct with all information 
			that is neccessary to handle events of this type
			\param event: a licq event
			\return a pointer to the converted event
		*/
		virtual gpointer mergeEvent(CUserEvent* event);	
	
	friend class IMUserDaemon;
	friend class IMOwnerDaemon;
};


//! the secure connection manager. Enables / Disables a secure connection
class IMSecurityManager: public IMEventManager
{
	public:
		IMSecurityManager(IMUserInfo *_info);
		~IMSecurityManager();
	
		guchar secureChannelSupport();
		void connectSecureChannel();
		void disconnectSecureChannel();
		gboolean secureChannelActivated();
		gboolean hasSecureChannelOnThisClient();
};




//! the update manager. Manages saving of user information and can send an update request
/*!
	The update manager itself doesn't have any events to be processed or read.
	Its only purpose is to save and to update the user information
*/
class IMUserUpdateManager: public IMEventManager
{
	public:
		guchar sendUpdateStep;
		//! Constructor
		/*!
			\param _info: a pointer to the user information struct (see IMEventManager::IMEventManager)
		*/
		IMUserUpdateManager(IMUserInfo *_info);
		//! Destructor
		~IMUserUpdateManager();
	
		//! save user information
		/*!
			stores the user information in the licq database and saves it
			\return no return value
		*/
		void saveUserInfo();
		//! updates user information
		/*!
			requests the icq server to update the user information. 
			\param aliasToKeep: if this variable is set the keepAliasOnUpdate flag is set and the new alias is the content of this variable
			\return no return value
		*/
		void updateUserInfo(gchar* aliasToKeep);
		//! sends the user information to the server
		/*!
			sends user information to the server
			\return no return value
		*/
		void sendUserInfo();
		
		gboolean finishEvent(ICQEvent* event);
		
};



//! the auto response manager.
/*!
	this manager sets the status to a specific user and loads + saves the templates
*/
class IMAutoResponseManager: public IMEventManager
{
	public:
		gboolean isOwnerManager;
	
		IMAutoResponseManager(IMUserInfo	*_info, gboolean isOwner);
		~IMAutoResponseManager();
	
		gboolean finishEvent(ICQEvent* event);
	
		void fetchAutoResponse();
	
		gboolean fetchTemplates(guint awayMode, GList** contents, GList** names);
		void	 writeTemplates(guint awayMode, GList* contents, GList* names);
		void setCustomResponse(gchar* msg, gboolean informUser = TRUE);
		gchar* getCustomResponse();	
};




//! the history manager. 
/*!
	the history manager loads and formats the licq history and can filter entries
*/
class IMHistoryManager: public IMEventManager
{
	public:
		guint readMask;
		gchar* pattern;
	
		IMHistoryManager(IMUserInfo* _info);
		~IMHistoryManager();
	
		//! loads the history from file
		/*!
			\return true if history was loaded
		*/
		gboolean loadHistory();
		//! loads the history and filters it
		/*!
			\param pattern: the filter pattern
			\return return value
		*/
		guchar loadHistoryFiltered(gchar* _pattern);
	
		//! stops loading the history
		/*!
			\return no return value
		*/
		void stopLoadingHistoryFiltered();
	
		//! returns the number of history entries
		/*!
			\return number of history entries
		*/
		guint historyLength();
	
		//! returns the current position of the history list iter
		/*!
			\return the current position
		*/
		gint historyPosition();
	
		//! returns a NULL terminated array of history entries
		/*!
			If something is read the iter is increased. Reset it with resetHistoryReading
			\param count: number of entries to be read
			\param increasePosition: should the iter be moved?
			\return the list (contains internal data and must not be modified)
		*/
		GList* getHistoryEntries(gint count, gboolean increasePosition);
		
		//! sets whether the history entries should be read reversely
		/*!
			\param reverse: should history be read reversely?
			\return no return value
		*/
		void setReadReverse(gboolean reverse);
		
		//! returns the state of the readReversely flag
		/*!
			\return the readReversely state
		*/
		gboolean getReadReverse();
		
		
		//! returns the reading iter
		void resetHistoryReading();
		
		//! moves the history iter 
		/*!
			\param steps: steps to move the iter (+ means right, - means left, if reverse is set the order permutes)
			\return no return value
		*/
		void moveHistoryPosition(gint steps);
		
		//! saves the history to a file
		/*!
			\param fileName: the file name
			\param overwriteExisting: if TRUE existing files will be overwritten
			\return 0 if everything went okay, otherwise an error code
		*/
		guchar saveHistory(gchar* fileName, gboolean overwriteExisting);
	
	private:
		gint 		num;
		gint  		numRead;
		gboolean 	readReversely;
		pthread_t	threadID;
		HistoryList licqList,
					ownList;
		HistoryListIter licqListIter;
	
		GList	*entries;
		//! unloads the history array
		void unloadHistory();
		void freeConvertedEntries();
	
		void filterLicqHistoryByMask();
	
		void doFilterHistory();
	
		gboolean loadLicqHistory();
	
	
		// thread
		static void *t_loadHistoryFiltered(IMHistoryManager* self); 
};




//! the message manager. Sends and retrieves messages
class IMMessageManager: public IMEventManager
{
	public:
		IMMessageManager(IMUserInfo	*_info);
		~IMMessageManager();
	
		void sendMessage(gchar* msg, gushort level = ICQ_TCPxMSG_NORMAL);
		void sendURL(gchar* url, gchar* msg, gushort level = ICQ_TCPxMSG_NORMAL);
		void sendTypingNotification(gchar nState);
		void setColors(GdkColor *foreground, GdkColor *background);
		void setColorsEnabled(gboolean enabled);
	
		void retrySendingEvent(ICQEvent* event, gushort level = ICQ_TCPxMSG_NORMAL);
	
		gboolean finishEvent(ICQEvent* event);
	
		void conversationUserAdded(IMUserDaemon* user);
		void conversationUserRemoved(IMUserDaemon* user);
	
		GList *getConversationUsers();
	
	protected:
		gboolean 	colorsEnabled;
		gchar		*msgCopy;
		CICQColor	*licqColor;
		GList		*conversationUsers;
	
		virtual gpointer mergeEvent(CUserEvent* event);
};


// the contacts manager
class IMContactsManager: public IMEventManager
{
	public:
		IMContactsManager(IMUserInfo* _info);
		~IMContactsManager();
	
		void sendContacts(GList* contacts);
	
		void retrySendingEvent(ICQEvent* event, gushort level = ICQ_TCPxMSG_NORMAL);
	
	protected:
		gpointer mergeEvent(CUserEvent* event);
};





// a gernal manager for actions that require a direct connection, admission ...
class IMAdmissionManager: public IMEventManager
{
	public:
		gboolean isServer;
		
		IMAdmissionManager(IMUserInfo	*_info);
		~IMAdmissionManager();
	
		// sends a request for doing something (file transfer, chatting ...)
		virtual void sendRequest(gchar* descr, gpointer data);
	
		// answers a request from a remote user
		virtual void answerRemoteRequest(gboolean accept, gchar* charData);
	
	protected:
		GIOChannel *channel;
		guint	   watchSource;
		virtual gpointer mergeEvent(CUserEvent* event);
	
		void installPipe(gint pipe, GIOFunc func);
};



//! the authorization manager. Sends and retrieves authorization events
class IMAuthorizationManager: public IMAdmissionManager
{
	public:
		IMAuthorizationManager(IMUserInfo *_info);
		~IMAuthorizationManager();
	
		virtual void sendRequest(gchar* descr, gpointer data);
		virtual void answerRemoteRequest(gboolean accept, gchar* charData);
	
	protected:
		virtual gpointer mergeEvent(CUserEvent* event);
};




// the file transfer manager
class IMFileTransferManager: public IMAdmissionManager
{
	public:
		gboolean isTransferring;
		
		IMFileTransferManager(IMUserInfo	*_info);
		~IMFileTransferManager();
	
		virtual void sendRequest(gchar* descr, gpointer data, gushort level = ICQ_TCPxMSG_NORMAL);
		virtual void answerRemoteRequest(gboolean accept, gchar* charData);
	
		virtual gboolean finishEvent(ICQEvent* event);
		void retrySendingEvent(ICQEvent* event, gushort level = ICQ_TCPxMSG_NORMAL);
	
		void	sendFiles();
	
		virtual void cancelInitatedEvent();

	
	protected:
		virtual gpointer mergeEvent(CUserEvent* event);
	
	private:
		CFileTransferManager *licqManager;
	
		static gboolean cb_pipeCallback(GIOChannel* source, GIOCondition condition, IMFileTransferManager* self);
		
};

/*
struct IMChatPipe
{
	GIOChannel *channel;
	guint	   watchSource;
	CChatManager	*licqManager;
};*/


// the chat manager
class IMChatManager: public IMAdmissionManager
{
	public:
		IMChatManager(IMUserInfo	*_info);
		~IMChatManager();
		virtual void sendRequest(gchar* descr, gpointer data, gushort mPort = 0, gushort level = ICQ_TCPxMSG_NORMAL);
		virtual void answerRemoteRequest(gboolean accept, gchar* charData, chatFontInfo* font = NULL, gushort mPort = 0);
	
		virtual gboolean finishEvent(ICQEvent* event);
		void retrySendingEvent(ICQEvent* event, gushort level = ICQ_TCPxMSG_NORMAL);
		virtual void cancelInitatedEvent();

		void sendInformation(chatSendType type, gchar data);
		void setColor(gboolean background, gushort r, gushort g, gushort b);
		void setFontSize(gushort size);
		void setFontFamily(gchar* family, guchar encoding, guchar style);
		void setFontFace(gboolean bold, gboolean italic, gboolean underline, gboolean strikeout);
	
		void sendKickAnswer(gulong uin, gboolean kick);
		void kickUser(gulong uin);
	
		gushort getChatPort();
	
	protected:
		virtual gpointer mergeEvent(CUserEvent* event);	 
	
	private:
		CChatManager *licqManager;	
	
		static gboolean cb_pipeCallback(GIOChannel* source, GIOCondition condition, IMChatManager* self);		
};


class IMGPGManager: public IMEventManager
{
	public:
		IMGPGManager(IMUserInfo *_info);
		~IMGPGManager();
	
		gchar* 		getGPGKey();
		void		setGPGKey(gchar* newGPGKey);
		gboolean	getGPGActive();
		void		setGPGActive(gboolean active);
};



// a manager for events you can nothing do with (mostly notifications)
class IMMiscManager: public IMEventManager
{
	public:
		IMMiscManager(IMUserInfo	*_info);
		~IMMiscManager();
	
	protected:
		gpointer mergeEvent(CUserEvent* event);
};





class IMUserDaemon: public IMSignalSource
{
	public:
		IMUserInfo			*info;	
		gpointer			dowry;
		IMUserDaemon		*owner;
		GList				*groups;
	
		IMUserDaemon(gchar* ID, guint _pluginID, IMUserDaemon *_owner);
		IMUserDaemon(ICQUser* _licqUser, IMUserDaemon *_owner);
		virtual ~IMUserDaemon();
	
		gboolean startCallback(gint command, gint lastResult, gpointer data)
				 {return IMSignalSource::startCallback(UE_UNDEFINED, command, lastResult, data);}
	
		// adds a manager to the managers list
		IMEventManager* addManager(IMEventManager *newManager);
	
		// tests all events in the queue for this manager
		void initializeManagerForUser(IMEventManager* man);
	
		// removes a manager from the managers list
		void removeManager(IMEventManager *toRemove);
	
		// removes a manager by the callback
		void removeManagerByCallback(gpointer removeCallback);
	
		// informs all managers in the managers list
		void informAllManagers(gint command, gint lastResult, gpointer data);
	
		// dispatches events (finds correct manager and adds an event there)
		virtual void dispatchPendingEvents();
	
		// tells a manager that an event has finished
		void finishEvent(ICQEvent* event);
		
		// adds an event to the event queue
		void addEventToQueue(CUserEvent* event, gboolean isOwnerEvent);
		
		// adds an event tag for a running event
		void addEventTag(gulong tag);
		
		// sets the conversation id
		void setConversationID(gulong newID);
		
		// gets the conversation id
		gulong getConversationID();
		
		// finds our current conversation id or creates one if neccessary
		gulong findConversationID();
		
		// adds a conversation user 
		void addConversationUser(IMUserDaemon* cuser, gulong convID);
		
		// removes a conversation user
		void removeConversationUser(IMUserDaemon* cuser, gulong convID);
		
		
		// creates a basicEventInfo-structure out of a CUserEvent
		basicEventInfo* createBasicEvent(CUserEvent* event);
		
		// clears an event
		void clearEvent(basicEventInfo *toClear, gboolean canBeDropped);
		
		// removes everything concerning a user
		void clearAllEvents(gboolean deleteEvents);
	
		// dispatches all kind of user information (sends to ALL managers)
		virtual void dispatchInformation(CICQSignal* signal);
	
		// updates user information
		void editUserInformation(gboolean update, gushort toUpdate, gint statusChangeArgument = 0);
		
		// updates category information
		void editUserInfoCategories(ICQUserCategory* cat, const struct SCategory *(*catfunc)(gushort), GList** catList, gboolean update);
	
		// updates user groups
		void editUserGroups(gboolean update, ICQUser* u);
		
		// clears category information
		void clearUserInfoCategories(GList	*cat);
		
		
		basicEventInfo* getEvent(gchar returnFlag);
		// void deleteEventType(gchar deleteFlag, gint type);
		
		// returns the length of the event queue
		guint getQueueCount();

		ICQUser	*getLicqUser();
		void	dropLicqUser(ICQUser* todrop);			
		
		// sets the status to the user
		virtual void setStatus(guint status);
		
		// sets the charset the user uses
		void setCharset(gchar* charset, gboolean saveInfo);
		
		// gets the accept modes for the user
		gboolean getAcceptModes(acceptMode mode);
		
		// sets the accept modes for the user
		void setAcceptMode(acceptMode mode, gboolean setting);
		
		// gets the licq groups
		gulong getLicqGroups(GroupType g);
		
		// sets the licq groups
		void setLicqGroups(GroupType g, gulong newGroups);
		
	protected:
		GList			*managers;
		// the general event queue
		GList			*basicQueue;	
		ICQUser			*licqUser;
		gulong			conversationID;
	
		IMEventCallback  callBack;
		gpointer		 callBackData;

	
	friend class IMOwnerDaemon;
};




// the group manager
class IMGroupManager
{
	public:
		GList* groups;
	
		IMGroupManager();
		~IMGroupManager();
	
		GList		*loadGroups();
		void   		renameGroup(gushort id, gchar* newName);
		groupInfo 	*addGroup(gchar* name, gint where);
		void   		removeGroup(gushort id);   
		void		clearGroups();
		groupInfo	*getNoGroup();
	
		gushort		getDefaultGroup();
		void		setDefaultGroup(gushort newGroup);
		gushort		getNewUsersGroup();
		void		setNewUsersGroup(gushort newGroup);
		void		swapGroups(gushort n1, gushort n2);
		void		resortGroups(GList* newGroups);
		void		checkForNewGroups();
	
		groupInfo	*getGroupByID(gushort id);
		groupInfo	*getGroupByIcqndID(gchar* icqndID);
		groupInfo	*getGroupByNum(gushort num);
		groupInfo	*getGroupByName(gchar* name);
};




void setLicqDaemon(CICQDaemon *daemon);
CICQDaemon* getLicqDaemon();

IMGroupManager* IO_getGroupManager();
void IO_setGroupManager(IMGroupManager* man);

IMSignalSource* IO_getGeneralSource();

#endif
