/***************************************************************************
 *            modeswindow.h
 *
 *  Fri Jul  8 03:03:04 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _MODESWINDOW_H
#define _MODESWINDOW_H

#include "basicwindow.h"
#include "imuserdaemon.h"
#include "gettext.h"

class modesWindow: public basicWindow
{
	public:
		modesWindow();
		~modesWindow();
		
	private:
		GtkWidget		*groupsView,
						*acceptAwayButton,
						*acceptNAButton,
						*acceptOccButton,
						*acceptDNDButton,
						*autoAcceptFilesButton,
						*autoAcceptChatsButton,
						*autoRequestSecureButton,
						*useGPGButton,
						*useRealIPButton,
						*useSpecialStatusButton,
						*specialStatusList,
						*onlineNotifyButton,
						*visibleListButton,
						*invisibleListButton,
						*ignoreListButton,
						*newUsersButton,
						*applyButton;
						

		GtkListStore	*groupsStore;	
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
	
		GtkWidget	*createButtonbar();
		GtkWidget	*createGroupsTab();
		GtkWidget	*createStatusTab();
		GtkWidget	*createAcceptTab();
		
		// callbacks
		static void cb_groupsListToggled(GtkCellRendererToggle *cell, gchar *pathStr, modesWindow* self);
		static void cb_someButtonClicked(modesWindow* self);
		static void cb_statusToUserButtonClicked(modesWindow* self);
		static void cb_applyButtonClicked(modesWindow* self);
};


#endif /* _MODESWINDOW_H */
