/***************************************************************************
 *            searchdialog.h
 *
 *  Mon Jun  6 00:29:36 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

#ifndef _SEARCHDIALOG_H
#define _SEARCHDIALOG_H

#include "icons.h"
#include "basicwindow.h"
#include "infowindow.h"
#include "processingani.h"
#include "utilities.h"
#include "imownerdaemon.h"
#include "imbuddy.h"	
#include "gettext.h"
#include "userutilities.h"
	
enum
{
	SFU_ALIAS,
	SFU_UIN,
	SFU_NAME,
	SFU_EMAIL,
	SFU_STATUS,
	SFU_SEXAGE,
	SFU_AUTHORIZE
};




class searchForUserDialog: public basicWindow
{
	public:
		searchForUserDialog();
		~searchForUserDialog();
	
	private:
		GtkWidget	*notebook,
					*aliasEntry,
					*fNameEntry,
					*lNameEntry,
					*cityEntry,
					*stateEntry,
					*companyNameEntry,
					*companyDepEntry,
					*companyPosEntry,
					*emailEntry,
					*keywordEntry,
					*ageList,
					*genderList,
					*langList,
					*countryList,
					*uinEntry,
					*onlineCheckbox,
					*resultsView,
					*statusLabel,
					*findByIDButton,
					*findByInfoButton,
					*infoNotebook,
					*infoLabel;
	
		GtkWidget	*searchButton,
					*resetButton,
					*addUserButton,
					*alertUserCheckbox,
					*closeButton,
					*infoButton,
					*messageButton,
					*chatButton,
					*filetransferButton;
	
	
		processingAni *searchAni;
	
		GtkListStore *resultsStore;
	
		GtkWidget	*createWindowContent();
		void		destroyWindowContent();
		void		windowActivated();
		gboolean	eventCallback(gint command, gint lastResult, gpointer info);
		void		updateUserButtons();
		void		addSearchResult(searchEventInfo *searchInfo);
		
		void		startSearch();
		void		stopSearch();
		void		resetSearch();
	
		GtkWidget	*createResultsList();
		GtkWidget	*createButtonbar();
		
		
		// callbacks
		static void cb_searchButtonClicked(searchForUserDialog* self);
		static void cb_resetButtonClicked(searchForUserDialog* self);
		static void cb_closeButtonClicked(searchForUserDialog* self);
		static void cb_moveResultsFocus(searchForUserDialog* self);
		static void cb_userButtonClicked(GtkWidget* w, searchForUserDialog* self);
		static void cb_addUsersButtonClicked(searchForUserDialog* self);
		static void cb_searchModeToggled(searchForUserDialog* self);
};

#endif /* _SEARCHDIALOG_H */
